<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>projectsinC</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="project-based-tutorials-in-c">Project Based Tutorials in C</h1>
    <p>
      A list of tutorials that work towards the making of small to large
      projects in C.
    </p>
    <h2 id="table-of-contents">Table of Contents</h2>
    <ul>
      <li><a href="#computer-architecture">Computer Architecture</a></li>
      <li><a href="#computer-networking">Computer Networking</a></li>
      <li><a href="#databases">Databases</a></li>
      <li><a href="#game-development">Game Development</a></li>
      <li><a href="#operating-systems">Operating Systems</a></li>
      <li><a href="#programming-languages">Programming Languages</a></li>
      <li><a href="#uncategorized">Uncategorized</a></li>
    </ul>
    <h2 id="computer-architecture">Computer Architecture</h2>
    <ul>
      <li>
        <a href="https://github.com/pervognsen/bitwise">Bitwise</a>
        <code>video</code> <code>abandoned</code>
      </li>
      <li><a href="http://emulator101.com/">Emulator 101</a></li>
      <li>
        <a href="https://felixangell.com/blogs/virtual-machine-in-c"
          >Implementing a Virtual Machine in C</a
        >
      </li>
      <li>
        Writing a Chip 8 Emulator <code>in-progress</code>
        <ul>
          <li>
            <a
              href="http://craigthomas.ca/blog/2014/06/21/writing-a-chip-8-emulator-part-1/"
              >Part 1</a
            >
          </li>
          <li>
            <a
              href="http://craigthomas.ca/blog/2014/07/17/writing-a-chip-8-emulator-part-2/"
              >Part 2</a
            >
          </li>
          <li>
            <a
              href="http://craigthomas.ca/blog/2015/02/19/writing-a-chip-8-emulator-draw-command-part-3/"
              >Part 3</a
            >
          </li>
          <li>
            <a
              href="http://craigthomas.ca/blog/2017/10/15/writing-a-chip-8-emulator-built-in-font-set-part-4/"
              >Part 4</a
            >
          </li>
          <li>
            <a
              href="http://craigthomas.ca/blog/2018/09/07/writing-a-chip-8-emulator-instruction-set-part-5/"
              >Part 5</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a href="https://cturt.github.io/cinoop.html"
          >Writing a Game Boy emulator</a
        >
      </li>
      <li>
        <a href="https://justinmeiners.github.io/lc3-vm/"
          >Write your Own Virtual Machine</a
        >
      </li>
    </ul>
    <h2 id="computer-networking">Computer Networking</h2>
    <ul>
      <li>
        <a href="http://beej.us/guide/bgnet/html/multi/index.html"
          >Beej’s Guide to Network Programming</a
        >
        <code>book</code>
      </li>
      <li>
        <a
          href="https://eli.thegreenplace.net/2017/concurrent-servers-part-1-introduction/"
          >Concurrent Servers</a
        >
      </li>
      <li>
        <a
          href="https://medium.com/from-the-scratch/http-server-what-do-you-need-to-know-to-build-a-simple-http-server-from-scratch-d1ef8945e4fa"
          >HTTP Server: Everything you need to know to Build a simple HTTP
          server from scratch</a
        >
      </li>
      <li>
        Let’s code a TCP/IP stack
        <ul>
          <li>
            <a
              href="http://www.saminiir.com/lets-code-tcp-ip-stack-1-ethernet-arp/"
              >Part 1: Ethernet &amp; ARP</a
            >
          </li>
          <li>
            <a
              href="http://www.saminiir.com/lets-code-tcp-ip-stack-2-ipv4-icmpv4/"
              >Part 2: IPv4 &amp; ICMPv4</a
            >
          </li>
          <li>
            <a
              href="http://www.saminiir.com/lets-code-tcp-ip-stack-3-tcp-handshake/"
              >Part 3: TCP Basics &amp; Handshake</a
            >
          </li>
          <li>
            <a
              href="http://www.saminiir.com/lets-code-tcp-ip-stack-4-tcp-data-flow-socket-api/"
              >Part 4: TCP Data Flow &amp; Socket API</a
            >
          </li>
          <li>
            <a
              href="http://www.saminiir.com/lets-code-tcp-ip-stack-5-tcp-retransmission/"
              >Part 5: TCP Retransmission</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a
          href="https://lettier.github.io/posts/2016-04-26-lets-make-a-ntp-client-in-c.html"
          >Let’s make a NTP Client in C</a
        >
      </li>
      <li>
        Write an MQTT broker from scratch
        <ul>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker"
              >Part 1 - The protocol</a
            >
          </li>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker-p2"
              >Part 2 - Networking</a
            >
          </li>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker-p3"
              >Part 3 - Server</a
            >
          </li>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker-p4"
              >Part 4 - Data structures</a
            >
          </li>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker-p5"
              >Part 5 - Topic abstraction</a
            >
          </li>
          <li>
            <a href="https://codepr.github.io/posts/sol-mqtt-broker-p6"
              >Part 6 - Handlers</a
            >
          </li>
        </ul>
      </li>
    </ul>
    <h2 id="databases">Databases</h2>
    <ul>
      <li>
        <a href="https://cstack.github.io/db_tutorial/"
          >Let’s Build a Simple Database</a
        >
      </li>
    </ul>
    <h2 id="game-development">Game Development</h2>
    <ul>
      <li>
        <a href="https://gtk.dashgl.com/?folder=Astroids">Astroids Clone</a>
      </li>
      <li>
        <a href="https://gtk.dashgl.com/?folder=Brickout">Brickout Clone</a>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLZ1QII7yudbc-Ky058TEaOstZHVbT-2hg"
          >Chess Engine In C</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLkTXsX7igf8edTYU92nU-f5Ntzuf-RKvW"
          >Coding A Sudoku Solver in C</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLkTXsX7igf8erbWGYT4iSAhpnJLJ0Nk5G"
          >Coding a Rogue/Nethack RPG in C</a
        >
        <code>video</code>
      </li>
      <li>
        <a href="https://www.udemy.com/course/game-loop-c-sdl/"
          >Create a Game Loop using C and SDL</a
        >
        <code>course</code>
      </li>
      <li>
        <a href="https://www.parallelrealities.co.uk/tutorials/#ppp"
          >Creating a 2D platformer</a
        >
      </li>
      <li>
        <a href="https://www.parallelrealities.co.uk/tutorials/#shooter"
          >Creating a 2D shoot ’em up</a
        >
      </li>
      <li>
        <a href="https://www.parallelrealities.co.uk/tutorials/#bad"
          >Creating a 2D top-down shooter</a
        >
      </li>
      <li>
        <a href="https://handmadehero.org/">Handmade Hero</a>
        <code>video</code> <code>in-progress</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLZ1QII7yudbd2ZHYSEWrSddsvD5PW_r5O"
          >Hangman</a
        >
        <code>video</code>
      </li>
      <li>
        <a href="https://nesdoug.com/">How to Program an NES game in C</a>
      </li>
      <li>
        <a href="https://helderman.github.io/htpataic/htpataic01.html"
          >How to Program a Text Adventure in C</a
        >
        <code>in-progress</code>
      </li>
      <li>
        <a href="https://jborza.github.io/games/2020/07/12/solitaire-cli.html"
          >Implementing Solitaire in C</a
        >
      </li>
      <li>
        <a href="https://gtk.dashgl.com/?folder=Invaders">Invaders Clone</a>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLeEj4c2zF7PaFv5MPYhNAkBGrkx4iPGJo"
          >Learn How To Develop Your Own GameBoy Games</a
        >
        <code>video</code> <code>in-progress</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLT6WFYYZE6uLMcPGS3qfpYm7T_gViYMMt"
          >Learn Video Game Programming in C</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLSkJey49cOgTSj465v2KbLZ7LMn10bCF9"
          >Let’s Make: Dangerous Dave</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PL7Ej6SUky1357r-Lqf_nogZWHssXP-hvH"
          >Making a game in C from scratch</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLlaINRtydtNWuRfd4Ra3KeD6L9FP_tDE7"
          >Making a Video Game from Scratch in C</a
        >
        <code>video</code> <code>in-progress</code>
      </li>
      <li>
        <a href="https://brennan.io/2015/06/12/tetris-reimplementation/"
          >On Tetris and Reimplementation</a
        >
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PL6Ikt4l3NbVjb7WR-eTgjOBMNCn7f3u7x"
          >SDL 2 Isometric Game Tutorial</a
        >
        <code>video</code> <code>in-progress</code>
      </li>
      <li>
        <a
          href="https://www.youtube.com/playlist?list=PLZ1QII7yudbc7_ZgXA-gIXmME41Rs2GP5"
          >Simple Tic Tac Toe in C</a
        >
        <code>video</code>
      </li>
      <li>
        Text Adventure <code>video</code> <code>in-progress</code>
        <ul>
          <li><a href="https://youtu.be/J_Igbh0RH8c">Episode 1</a></li>
          <li>
            <a href="https://www.youtube.com/watch?v=7dYKhiruW1M">Episode 2</a>
          </li>
        </ul>
      </li>
      <li>
        <a href="https://www.youtube.com/watch?v=gCVMkKgs3uQ"
          >Tic-tac-toe Game in C with SDL</a
        >
        <code>video</code>
      </li>
      <li>
        Video Game Physics Tutorial
        <ul>
          <li>
            <a
              href="https://www.toptal.com/game/video-game-physics-part-i-an-introduction-to-rigid-body-dynamics"
              >Part I: An Introduction to Rigid Body Dynamics</a
            >
          </li>
          <li>
            <a
              href="https://www.toptal.com/game/video-game-physics-part-ii-collision-detection-for-solid-objects"
              >Part II: Collision Detection for Solid Objects</a
            >
          </li>
          <li>
            <a
              href="https://www.toptal.com/game/video-game-physics-part-iii-constrained-rigid-body-simulation"
              >Part III: Constrained Rigid Body Simulation</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a href="https://www.hanshq.net/othello.html"
          >Write Othello Game from scratch in C</a
        >
      </li>
      <li>
        <a href="https://www.hanshq.net/fire.html"
          >Write The Old-School Fire Effect and Bare-Metal Programming in
          Assembly and C</a
        >
      </li>
      <li>
        <a href="https://www.youtube.com/watch?v=yFLa3ln16w0"
          >Writing 2D Games in C using SDL</a
        >
        <code>video</code>
      </li>
      <li>
        <a
          href="https://www.reinterpretcast.com/writing-a-game-boy-advance-game"
          >Writing a Game Boy Advance Game</a
        >
      </li>
    </ul>
    <h2 id="operating-systems">Operating Systems</h2>
    <ul>
      <li>
        <a href="https://github.com/jserv/mini-arm-os"
          >Build a minimal multi-tasking OS kernel for ARM from scratch</a
        >
      </li>
      <li>
        <a href="https://github.com/tokenrove/build-your-own-shell"
          >Build Your Own Shell</a
        >
      </li>
      <li>
        <a href="https://jsandler18.github.io/"
          >Building an Operating System for the Raspberry Pi</a
        >
      </li>
      <li>
        <a
          href="https://blog.holbertonschool.com/hack-virtual-memory-stack-registers-assembly-code/"
          >Hack the Virtual Memory</a
        >
      </li>
      <li>
        <a href="https://github.com/cfenollosa/os-tutorial"
          >How to Create an OS from Scratch</a
        >
        <code>in-progress</code>
      </li>
      <li>
        <a
          href="https://david942j.blogspot.com/2018/10/note-learning-kvm-implement-your-own.html"
          >Learning KVM - implement your own kernel</a
        >
      </li>
      <li>
        <a href="https://github.com/s-matyukevich/raspberry-pi-os"
          >Learning operating system development using Linux kernel and
          Raspberry Pi</a
        >
        <code>in-progress</code>
      </li>
      <li>
        <a href="https://github.com/kamalmarhubi/shell-workshop"
          >Let’s build a shell!</a
        >
      </li>
      <li>
        <a href="https://danluu.com/malloc-tutorial/">Let’s Write a Malloc</a>
      </li>
      <li>
        Let’s write a Kernel
        <ul>
          <li>
            <a
              href="https://arjunsreedharan.org/post/82710718100/kernel-101-lets-write-a-kernel"
              >Part 1 - Kernel 101</a
            >
          </li>
          <li>
            <a
              href="https://arjunsreedharan.org/post/99370248137/kernel-201-lets-write-a-kernel-with-keyboard"
              >Part 2 - Kernel 201</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a href="https://blog.lizzie.io/linux-containers-in-500-loc.html"
          >Linux Containers in 500 Lines of Code</a
        >
      </li>
      <li>
        <a
          href="https://medium.com/@lduck11007/operating-systems-development-for-dummies-3d4d786e8ac"
          >Operating systems development for Dummies</a
        >
      </li>
      <li>
        <a href="https://tuhdo.github.io/os01/"
          >Operating Systems: From 0 to 1</a
        >
        <code>book</code>
      </li>
      <li>
        <a href="https://www.ops-class.org/"
          >OS161: Everything you need to learn about operating systems</a
        >
        <code>course</code>
      </li>
      <li>
        Re-Writing BSD 4.4 Shell Commands: <code>video</code>
        <ul>
          <li><a href="https://www.youtube.com/watch?v=MCuzvy79WWQ">cat</a></li>
          <li>
            <a href="https://www.youtube.com/watch?v=p7uJBl4A_BA">chmod</a>
          </li>
          <li>
            <a href="https://www.youtube.com/watch?v=69CYF7nJKj8">echo</a>
          </li>
          <li>
            <a href="https://www.youtube.com/watch?v=t96qYd4OUBM">mkdir</a>
          </li>
        </ul>
      </li>
      <li>
        <a href="http://www.jamesmolloy.co.uk/tutorial_html/"
          >Roll your own toy UNIX-clone OS</a
        >
      </li>
      <li>
        <a href="https://littleosbook.github.io/"
          >The little book about OS development</a
        >
        <code>book</code>
      </li>
      <li>
        <a href="https://brennan.io/2015/01/16/write-a-shell-in-c/"
          >Write a Shell in C</a
        >
      </li>
      <li>
        <a
          href="https://arjunsreedharan.org/post/148675821737/write-a-simple-memory-allocator"
          >Write a Simple Memory Allocator</a
        >
      </li>
      <li>
        <a href="https://brennan.io/2016/11/14/kernel-dev-ep3/"
          >Write a System Call</a
        >
      </li>
      <li>
        <a href="https://www.cs.nmsu.edu/~pfeiffer/fuse-tutorial/"
          >Writing a FUSE Filesystem</a
        >
      </li>
      <li>
        <a href="https://danishprakash.github.io/2018/01/15/write-a-shell.html"
          >Writing a shell in C</a
        >
      </li>
      <li>
        Writing a Unix Shell
        <ul>
          <li>
            <a
              href="https://indradhanush.github.io/blog/writing-a-unix-shell-part-1"
              >Part 1</a
            >
          </li>
          <li>
            <a
              href="https://indradhanush.github.io/blog/writing-a-unix-shell-part-2"
              >Part 2</a
            >
          </li>
          <li>
            <a
              href="https://indradhanush.github.io/blog/writing-a-unix-shell-part-3"
              >Part 3</a
            >
          </li>
        </ul>
      </li>
    </ul>
    <h2 id="programming-languages">Programming Languages</h2>
    <ul>
      <li>
        <a href="https://github.com/DoctorWkt/acwj"
          >A Compiler Writing Journey</a
        >
      </li>
      <li>
        <a
          href="https://www.cs.princeton.edu/courses/archive/spr09/cos333/beautiful.html"
          >A Regular Expression Matcher</a
        >
      </li>
      <li>
        <a href="https://swtch.com/~rsc/regexp/regexp1.html"
          >A Regular Expression Matching Can Be Simple And Fast</a
        >
      </li>
      <li>
        <a
          href="http://journal.stuffwithstuff.com/2013/12/08/babys-first-garbage-collector/"
          >Baby’s First Garbage Collector</a
        >
      </li>
      <li>
        <a href="http://www.buildyourownlisp.com/">Build Your Own Lisp</a>
        <code>book</code>
      </li>
      <li>
        <a href="https://holub.com/goodies/compiler/compilerDesignInC.pdf"
          >Compiler Design in C</a
        >
        <code>book</code>
      </li>
      <li>
        <a href="http://www.craftinginterpreters.com/">Crafting Interpreters</a>
        <code>book</code> <em>Chapters 14-30</em>
      </li>
      <li>
        <a href="https://github.com/lotabout/Let-s-build-a-compiler"
          >Let’s Build a Compiler: A C &amp; x86 version</a
        >
      </li>
      <li>
        Write a C Interpreter
        <ul>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/0-Preface.md"
              >Part 0 - Preface</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/1-Skeleton.md"
              >Part 1 - Skeleton</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/2-Virtual-Machine.md"
              >Part 2 - Virtual Machine</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/3-Lexer.md"
              >Part 3 - Lexer</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/4-Top-down-Parsing.md"
              >Part 4 - Top-down Parsing</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/5-Variables.md"
              >Part 5 - Variables</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/6-Functions.md"
              >Part 6 - Functions</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/7-Statements.md"
              >Part 7 - Statements</a
            >
          </li>
          <li>
            <a
              href="https://github.com/lotabout/write-a-C-interpreter/blob/master/tutorial/en/8-Expressions.md"
              >Part 8 - Expressions</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a href="http://maplant.com/gc.html"
          >Writing a Simple Garbage Collector in C</a
        >
      </li>
      <li>
        Scheme from Scratch
        <ul>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-introduction"
              >Part 1 - Introduction</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_1-integers"
              >Part 2 - Integers</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_2-booleans"
              >Part 3 - Booleans</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_3-characters"
              >Part 4 - Characters</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_4-strings"
              >Part 5 - Strings</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_5-the-empty-list"
              >Part 6 - The Empty List</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_6-pairs"
              >Part 7 - Pairs</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_7-symbols"
              >Part 8 - Symbols</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_8-quote"
              >Part 9 - Quote</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_9-environments"
              >Part 10 - Environments</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_10-if"
              >Part 11 - if</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_11-primitive-procedures-part-1"
              >Part 12 - Primitive Procedures Part 1</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_12-primitive-procedures-part-2"
              >Part 13 - Primitive Procedures Part 2</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_13-lambda-the-ultimate"
              >Part 14 - Lambda the Ultimate</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_14-begin"
              >Part 15 - Begin</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_15-cond"
              >Part 16 - Cond</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_16-let"
              >Part 17 - Let</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_17-and-and-or"
              >Part 18 - And and Or</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_18-apply"
              >Part 19 - Apply</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_19-eval"
              >Part 20 - Eval</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_20-io"
              >Part 21 - I/O</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_21-standard-library"
              >Part 22 - Standard Library</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-v0_22-garbage-collection"
              >Part 23 - Garbage Collection</a
            >
          </li>
          <li>
            <a
              href="http://peter.michaux.ca/articles/scheme-from-scratch-bootstrap-conclusion"
              >Part 24 - Conclusion</a
            >
          </li>
        </ul>
      </li>
    </ul>
    <h2 id="uncategorized">Uncategorized</h2>
    <ul>
      <li>
        A dummy blockchain implementation in C
        <ul>
          <li>
            <a href="https://myram.xyz/c-blockchain-implementation-1/"
              >Part 1</a
            >
          </li>
          <li>
            <a href="https://myram.xyz/c-blockchain-implementation-2/"
              >Part 2</a
            >
          </li>
        </ul>
      </li>
      <li>
        <a href="https://viewsourcecode.org/snaptoken/kilo/"
          >Build Your Own Text Editor</a
        >
      </li>
      <li>
        <a href="http://dranger.com/ffmpeg/ffmpeg.html"
          >How to Write a Video Player in Less Than 1000 Lines</a
        >
      </li>
      <li>
        <a href="https://github.com/leandromoreira/ffmpeg-libav-tutorial"
          >Learn FFmpeg libav the Hard Way</a
        >
        <code>in-progress</code>
      </li>
      <li>
        <a href="https://github.com/jamesroutley/write-a-hash-table"
          >Write a hash table in C</a
        >
      </li>
      <li>
        <a href="https://www.hanshq.net/bigint.html"
          >Write BigInt Calculator in C</a
        >
      </li>
      <li>
        <a href="https://www.hanshq.net/zip.html"
          >Write Your Own Zip from scratch in C</a
        >
      </li>
      <li>
        <a href="http://www.codedrome.com/svg-library-in-c/"
          >Writing an SVG Library</a
        >
      </li>
    </ul>
  </body>
</html>
